blob: a1981480d9b5f7a35de649ad5b6725ce1c7a821a [file] [log] [blame]
garciadeblas16304ba2016-05-11 14:47:39 +02001#!/bin/bash
2
3##
4# Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5# This file is part of openmano
6# All Rights Reserved.
7#
8# Licensed under the Apache License, Version 2.0 (the "License"); you may
9# not use this file except in compliance with the License. You may obtain
10# a copy of the License at
11#
12# http://www.apache.org/licenses/LICENSE-2.0
13#
14# Unless required by applicable law or agreed to in writing, software
15# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17# License for the specific language governing permissions and limitations
18# under the License.
19#
20# For those usages not covered by the Apache License, Version 2.0 please
21# contact with: nfvlabs@tid.es
22##
23
tierno76841842016-09-27 09:18:28 +000024#ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
garciadeblas16304ba2016-05-11 14:47:39 +020025#Get needed packages, source code and configure to run openmano
26#Ask for database user and password if not provided
garciadeblas16304ba2016-05-11 14:47:39 +020027
28function usage(){
tiernoc50e5da2016-07-06 17:49:45 +020029 echo -e "usage: sudo $0 [OPTIONS]"
tierno45a52852016-08-26 14:39:42 +020030 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
tiernoc50e5da2016-07-06 17:49:45 +020032 echo -e " OPTIONS"
tierno45a52852016-08-26 14:39:42 +020033 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
garciadeblas89b3d842016-09-19 15:18:33 +020035 echo -e " -q --quiet: install in unattended mode"
tierno45a52852016-08-26 14:39:42 +020036 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
tierno26777652016-11-15 17:33:13 +000038 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
39 echo -e " --force: makes idenpotent, delete previous installations folders if needed"
garciadeblas89b3d842016-09-19 15:18:33 +020040 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
tierno76841842016-09-27 09:18:28 +000041 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
garciadeblas5b1a6642017-04-18 10:10:31 +020042 echo -e " --no-db: do not install mysql server"
garciadeblas16304ba2016-05-11 14:47:39 +020043}
44
45function install_packages(){
46 [ -x /usr/bin/apt-get ] && apt-get install -y $*
tiernoc50e5da2016-07-06 17:49:45 +020047 [ -x /usr/bin/yum ] && yum install -y $*
garciadeblas16304ba2016-05-11 14:47:39 +020048
49 #check properly installed
50 for PACKAGE in $*
51 do
52 PACKAGE_INSTALLED="no"
53 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
54 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
55 if [ "$PACKAGE_INSTALLED" = "no" ]
56 then
tiernoc50e5da2016-07-06 17:49:45 +020057 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
garciadeblas89b3d842016-09-19 15:18:33 +020058 exit 1
garciadeblas16304ba2016-05-11 14:47:39 +020059 fi
60 done
61}
62
tierno45a52852016-08-26 14:39:42 +020063GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
tiernoc50e5da2016-07-06 17:49:45 +020064DBUSER="root"
65DBPASSWD=""
66DBPASSWD_PARAM=""
67QUIET_MODE=""
tierno45a52852016-08-26 14:39:42 +020068DEVELOP=""
garciadeblas89b3d842016-09-19 15:18:33 +020069FORCEDB=""
tierno26777652016-11-15 17:33:13 +000070FORCE=""
garciadeblas89b3d842016-09-19 15:18:33 +020071NOCLONE=""
tierno76841842016-09-27 09:18:28 +000072NO_PACKAGES=""
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +030073NO_DB=""
tiernoc50e5da2016-07-06 17:49:45 +020074while getopts ":u:p:hiq-:" o; do
75 case "${o}" in
76 u)
77 export DBUSER="$OPTARG"
78 ;;
79 p)
80 export DBPASSWD="$OPTARG"
81 export DBPASSWD_PARAM="-p$OPTARG"
82 ;;
83 q)
84 export QUIET_MODE=yes
85 export DEBIAN_FRONTEND=noninteractive
86 ;;
87 h)
88 usage && exit 0
89 ;;
90 -)
91 [ "${OPTARG}" == "help" ] && usage && exit 0
tierno45a52852016-08-26 14:39:42 +020092 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
garciadeblas89b3d842016-09-19 15:18:33 +020093 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
tierno26777652016-11-15 17:33:13 +000094 [ "${OPTARG}" == "force" ] && FORCEDB="y" && FORCE="y" && continue
garciadeblas89b3d842016-09-19 15:18:33 +020095 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
tierno45a52852016-08-26 14:39:42 +020096 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
tierno76841842016-09-27 09:18:28 +000097 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +030098 [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue
tiernoc50e5da2016-07-06 17:49:45 +020099 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
100 exit 1
101 ;;
102 \?)
103 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
104 exit 1
105 ;;
106 :)
107 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
108 exit 1
109 ;;
110 *)
111 usage >&2
garciadeblas89b3d842016-09-19 15:18:33 +0200112 exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200113 ;;
114 esac
115done
garciadeblas16304ba2016-05-11 14:47:39 +0200116
tiernoc50e5da2016-07-06 17:49:45 +0200117#check root privileges and non a root user behind
garciadeblas89b3d842016-09-19 15:18:33 +0200118[ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200119if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
120then
121 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
122 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
123 export SUDO_USER=root
124fi
garciadeblas16304ba2016-05-11 14:47:39 +0200125
126#Discover Linux distribution
127#try redhat type
128[ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
129#if not assuming ubuntu type
130[ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
131if [ "$_DISTRO" == "Ubuntu" ]
132then
tierno45a52852016-08-26 14:39:42 +0200133 _RELEASE=$(lsb_release -rs)
134 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200135 then
tierno45a52852016-08-26 14:39:42 +0200136 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
tiernoc50e5da2016-07-06 17:49:45 +0200137 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
tierno45a52852016-08-26 14:39:42 +0200138 _RELEASE = 14
garciadeblas16304ba2016-05-11 14:47:39 +0200139 fi
140elif [ "$_DISTRO" == "CentOS" ]
141then
142 _RELEASE="7"
143 if ! cat /etc/redhat-release | grep -q "7."
144 then
tiernoc50e5da2016-07-06 17:49:45 +0200145 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
146 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200147 fi
148elif [ "$_DISTRO" == "Red" ]
149then
150 _RELEASE="7"
151 if ! cat /etc/redhat-release | grep -q "7."
152 then
tiernoc50e5da2016-07-06 17:49:45 +0200153 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
154 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200155 fi
156else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
157 _DISTRO_DISCOVER=$_DISTRO
158 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
159 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
tiernoc50e5da2016-07-06 17:49:45 +0200160 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
161 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200162fi
163
tierno26777652016-11-15 17:33:13 +0000164#check if installed as a service
165INSTALL_AS_A_SERVICE=""
166[[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
167#Next operations require knowing OPENMANO_BASEFOLDER
168if [[ -z "$NOCLONE" ]]; then
tiernoaa5832d2016-12-07 16:20:25 +0100169 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
170 OPENMANO_BASEFOLDER=__openmano__${RANDOM}
171 else
172 OPENMANO_BASEFOLDER="${PWD}/openmano"
173 fi
174 [[ -n "$FORCE" ]] && rm -rf $OPENMANO_BASEFOLDER #make idempotent
tierno26777652016-11-15 17:33:13 +0000175else
176 HERE=$(realpath $(dirname $0))
177 OPENMANO_BASEFOLDER=$(dirname $HERE)
178fi
garciadeblas16304ba2016-05-11 14:47:39 +0200179
180
tierno76841842016-09-27 09:18:28 +0000181if [[ -z "$NO_PACKAGES" ]]
182then
garciadeblas16304ba2016-05-11 14:47:39 +0200183echo '
184#################################################################
185##### UPDATE REPOSITORIES #####
186#################################################################'
187[ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
188
189[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
190[ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
191[ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
192 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
193[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
194
tierno76841842016-09-27 09:18:28 +0000195fi
garciadeblas16304ba2016-05-11 14:47:39 +0200196
tierno76841842016-09-27 09:18:28 +0000197if [[ -z "$NO_PACKAGES" ]]
198then
garciadeblas16304ba2016-05-11 14:47:39 +0200199echo '
200#################################################################
201##### INSTALL REQUIRED PACKAGES #####
202#################################################################'
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +0300203[ "$_DISTRO" == "Ubuntu" ] && install_packages "git screen wget mysql-client"
204[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git screen wget mariadb-client"
garciadeblas16304ba2016-05-11 14:47:39 +0200205
garciadeblas16304ba2016-05-11 14:47:39 +0200206echo '
207#################################################################
208##### INSTALL PYTHON PACKAGES #####
209#################################################################'
bayramovfe3f3c92016-10-04 07:53:41 +0400210[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
211[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
tiernof70d0962017-01-30 12:39:09 +0100212#The only way to install python-bottle on Centos7 is with easy_install or pip
213[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
bayramovfe3f3c92016-10-04 07:53:41 +0400214
215#required for vmware connector TODO move that to separete opt in install script
216sudo pip install --upgrade pip
217sudo pip install pyvcloud
218sudo pip install progressbar
219sudo pip install prettytable
bhangarefda5f7c2017-01-12 23:50:34 -0800220sudo pip install pyvmomi
garciadeblas16304ba2016-05-11 14:47:39 +0200221
tiernof70d0962017-01-30 12:39:09 +0100222#requiered for AWS connector
223[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto"
224[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exist with this name, or PIP should be used
garciadeblas16304ba2016-05-11 14:47:39 +0200225
226#install openstack client needed for using openstack as a VIM
tierno93bffb42016-12-31 17:08:51 +0100227[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient"
228[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient #TODO revise if gcc python-pip is needed
tierno76841842016-09-27 09:18:28 +0000229fi #[[ -z "$NO_PACKAGES" ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200230
garciadeblas89b3d842016-09-19 15:18:33 +0200231if [[ -z $NOCLONE ]]; then
232 echo '
garciadeblas16304ba2016-05-11 14:47:39 +0200233#################################################################
234##### DOWNLOAD SOURCE #####
235#################################################################'
tierno26777652016-11-15 17:33:13 +0000236 su $SUDO_USER -c "git clone ${GIT_URL} ${OPENMANO_BASEFOLDER}"
237 su $SUDO_USER -c "cp ${OPENMANO_BASEFOLDER}/.gitignore-common ${OPENMANO_BASEFOLDER}/.gitignore"
tiernob1c42b62016-12-16 00:24:23 +0100238 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} checkout tags/v1.0.2"
garciadeblas89b3d842016-09-19 15:18:33 +0200239fi
garciadeblas16304ba2016-05-11 14:47:39 +0200240
garciadeblas16304ba2016-05-11 14:47:39 +0200241if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
242then
243 echo '
244#################################################################
245##### CONFIGURE firewalld #####
246#################################################################'
tiernoc50e5da2016-07-06 17:49:45 +0200247 KK=yes
248 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
garciadeblas16304ba2016-05-11 14:47:39 +0200249 if [ "$KK" != "n" -a "$KK" != "no" ]
250 then
251 #Creates a service file for openmano
252 echo '<?xml version="1.0" encoding="utf-8"?>
253<service>
254 <short>openmanod</short>
255 <description>openmanod service</description>
256 <port protocol="tcp" port="9090"/>
257</service>' > /etc/firewalld/services/openmanod.xml
258 #put proper permissions
259 pushd /etc/firewalld/services > /dev/null
260 restorecon openmanod.xml
261 chmod 640 openmanod.xml
262 popd > /dev/null
263 #Add the openmanod service to the default zone permanently and reload the firewall configuration
264 firewall-cmd --permanent --add-service=openmanod > /dev/null
265 firewall-cmd --reload > /dev/null
266 echo "done."
267 else
268 echo "skipping."
269 fi
270fi
271
272echo '
273#################################################################
274##### CONFIGURE OPENMANO CLIENT #####
275#################################################################'
tierno26777652016-11-15 17:33:13 +0000276#creates a link at ~/bin if not configured as a service
277if [[ -z "$INSTALL_AS_A_SERVICE" ]]
tiernoc50e5da2016-07-06 17:49:45 +0200278then
tierno26777652016-11-15 17:33:13 +0000279 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
280 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
281 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
282 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
tiernoaa5832d2016-12-07 16:20:25 +0100283 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
284 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
285 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh' "'${HOME}/bin/service-openmano'
tierno26777652016-11-15 17:33:13 +0000286
287 #insert /home/<user>/bin in the PATH
288 #skiped because normally this is done authomatically when ~/bin exist
289 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
290 #then
291 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
292 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
293 #fi
294 if [[ $SUDO_USER == root ]]
tiernoc50e5da2016-07-06 17:49:45 +0200295 then
tierno26777652016-11-15 17:33:13 +0000296 if ! echo $PATH | grep -q "${HOME}/bin"
297 then
298 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
299 fi
300 fi
301fi
garciadeblas16304ba2016-05-11 14:47:39 +0200302
303#configure arg-autocomplete for this user
304#in case of minimal instalation this package is not installed by default
305[[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
306#su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
307su $SUDO_USER -c 'activate-global-python-argcomplete --user'
tiernoc50e5da2016-07-06 17:49:45 +0200308if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200309then
310 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
tiernoc50e5da2016-07-06 17:49:45 +0200311 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200312fi
313
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +0300314if [ -z "$NO_DB" ]; then
315echo '
316#################################################################
317##### INSTALL DATABASE SERVER #####
318#################################################################'
tierno45a52852016-08-26 14:39:42 +0200319
Gennadiy Dubina89cb0d12017-04-03 15:46:41 +0300320 if [ -n "$QUIET_MODE" ]; then
321 DB_QUIET='-q'
322 fi
323 if [ -n "$FORCEDB" ]; then
324 DB_FORCE='--forcedb'
325 fi
326 ${OPENMANO_BASEFOLDER}/scripts/install-db-server.sh -u $DBUSER $DBPASSWD_PARAM $DB_QUIET $DB_FORCE || exit 1
327fi
tierno45a52852016-08-26 14:39:42 +0200328
tierno26777652016-11-15 17:33:13 +0000329if [[ -n "$INSTALL_AS_A_SERVICE" ]]
tierno45a52852016-08-26 14:39:42 +0200330then
331echo '
332#################################################################
333##### CONFIGURE OPENMANO SERVICE #####
334#################################################################'
335
tiernoaa5832d2016-12-07 16:20:25 +0100336 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
tierno26777652016-11-15 17:33:13 +0000337# rm -rf ${OPENMANO_BASEFOLDER}
tierno45a52852016-08-26 14:39:42 +0200338# alias service-openmano="service openmano"
339# echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
340
341 echo
tierno26777652016-11-15 17:33:13 +0000342 echo "Done! installed at /opt/openmano"
343 echo " Manage server with 'sudo service openmano start|stop|status|...' "
tierno45a52852016-08-26 14:39:42 +0200344
345
346else
347
348 echo
349 echo "Done! you may need to logout and login again for loading client configuration"
tierno26777652016-11-15 17:33:13 +0000350 echo " Run './${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh start' for starting openmano in a screen"
tierno45a52852016-08-26 14:39:42 +0200351
352fi
garciadeblas16304ba2016-05-11 14:47:39 +0200353